#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_syncmanager4xi.py">
#<abstract4xi abstract = "tests syncmanager4xi"/>
#<verify4xi verification = "10" target = "syncmanager4xi.py"/>
#<contextualize4xi context = "array4xi.py; authenticationstring4xi.py; boundedsemaphore4xi.py; condition4xi.py; event4xi.py; joinablequeue4xi.py; lock4xi.py;  manager4xi.py; namespace4xi.py; pool4xi.py; popen4xi.py; queue4xi.py; rlock4xi.py; semaphore4xi.py; server4xi.py; token4xi.py; value4xi.py; acquirerproxy4xi.py; arrayproxy4xi.py; eventproxy4xi.py; conditionproxy4xi.py; dictproxy4xi.py; iteratorproxy4xi.py; listproxy4xi.py; namespaceproxy4xi.py; poolproxy4xi.py; valueproxy4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'test_syncmanager4xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading
import array
import collections
import time
import atexit
import weakref
import queue
from queue import Empty, Full
import threading
import datetime
from time import gmtime, strftime
import _winapi

# -------------------------------------------------------------------------------------------------
# conditional imports                              
# -------------------------------------------------------------------------------------------------
try:
    from cPickle import PicklingError
except ImportError:
    from pickle import PicklingError


# -------------------------------------------------------------------------------------------------
# Standard imports of multiprocessing package                            
# ------------------------------------------------------------------------------------------------  
from multiprocessing.managers import Array
from multiprocessing.synchronize import BoundedSemaphore
from multiprocessing.synchronize import Condition
from multiprocessing.synchronize import Lock
from multiprocessing.managers import Namespace
from multiprocessing.pool import Pool 
from multiprocessing.synchronize import RLock
from multiprocessing.synchronize import Semaphore
from multiprocessing.managers import Value

# -------------------------------------------------------------------------------------------------
# Proxy imports of multiprocessing package                           
# -------------------------------------------------------------------------------------------------
from multiprocessing.managers import AcquirerProxy
from multiprocessing.managers import ArrayProxy
from multiprocessing.managers import ConditionProxy
from multiprocessing.managers import DictProxy
from multiprocessing.managers import EventProxy
from multiprocessing.managers import IteratorProxy
from multiprocessing.managers import ListProxy
from multiprocessing.managers import NamespaceProxy    
from multiprocessing.managers import PoolProxy
from multiprocessing.managers import ValueProxy
#"
#/>


   
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from acquirerproxy4xi import AcquirerProxy4Xi
from all_methods4xi import all_methods4xi
from array4xi import Array4Xi
from arrayproxy4xi import ArrayProxy4Xi
from authenticationstring4xi import AuthenticationString4Xi

from boundedsemaphore4xi import BoundedSemaphore4Xi

from condition4xi import Condition4Xi
from conditionproxy4xi import ConditionProxy4Xi
from constant_family4xi import get_default_family4xi

from date4xi import date4xi
from dictproxy4xi import DictProxy4Xi

from event4xi import Event4Xi
from eventproxy4xi import EventProxy4Xi

from iteratorproxy4xi import IteratorProxy4Xi

from joinablequeue4xi import JoinableQueue4Xi

from listproxy4xi import ListProxy4Xi
from lock4xi import Lock4Xi

from manager4xi import Manager4Xi

from namespace4xi import Namespace4Xi
from namespaceproxy4xi import NamespaceProxy4Xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      
from pool4xi import Pool4Xi
from poolproxy4xi import PoolProxy4Xi
from popen4xi import Popen4Xi

from queue4xi import Queue4Xi

from rlock4xi import RLock4Xi

from semaphore4xi import Semaphore4Xi
from server4xi import Server4Xi
from syncmanager4xi import SyncManager4Xi

from time4xi import time4xi
from token4xi import Token4Xi

from value4xi import Value4Xi
from valueproxy4xi import ValueProxy4Xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'AcquirerProxy4Xi': 'NACK4TRACE',
        'AfterFork4Xi': 'NACK4TRACE',
        'Array4Xi': 'NACK4TRACE',
        'Barrier4Xi': 'NACK4TRACE',
        'Finalize4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE',
        'Pool4Xi': 'NACK4TRACE',
        'Process4Xi': 'NACK4TRACE',
        'State4Xi': 'NACK4TRACE',
        'Token4Xi': 'NACK4TRACE',
        'Value4Xi': 'NACK4TRACE',
        'SyncManager4Xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>   

# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   trace to XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-sync-manager-test4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing SyncManager4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for SyncManager4Xi in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-sync-manager-test4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for SyncManager4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations SyncManager4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-sync-manager-test4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for SyncManager4Xi in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for SyncManager4Xi in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------
          
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "func2xi" usage = "
# Python functions can have keyword-only arguments listed after the * parameter and before the ** paramter if any, e.g.
# def f(a, b, *args, c, d = 42, e, **kwds):
#                 e c, d and e cannot be passed as position arguments and must be passed as keyword arguments
#                 c and e are required keyword arguments, since they do not have a default value
# if the parameter name after the * is omitted, the function will not accept any extra positional arguments
# def g(a, b, *, c, d): ...takes exactly two positional parameters and has two required keyword parameters
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">                       
# ------------------------------------------------------------------------------------------------- 

def func4xi(token, serializer, incref, **kwds):

    return True

     

#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "DragonXi" usage = "
#   returns a manager object associated with a running server process
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">                       
# ------------------------------------------------------------------------------------------------- 
def DragonXi():
#     '''
#     Returns a manager associated with a running server process
#     The managers methods such as `Lock()`, `Condition()` and `Queue()`
#     can be used to create shared objects.
#     '''
     dragonxi = SyncManager4Xi()
#     dragonxi.start() <--- skipped this because the idea is that main uses and tests the object
     return dragonxi
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "test" usage = "
#   test function for a class object 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">                       
# -------------------------------------------------------------------------------------------------    
def test(obj):
    
    # ---------------------------------------------------------------------------------------------
    # Information about the module
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("\n TESTING STARTED WITH OBJECT")
    print('=' *33)
        
    # ---------------------------------------------------------------------------------------------
    # All methods of this object
    # ---------------------------------------------------------------------------------------------
    print('=' *33)    
    print("\n ALL METHODS OF OBJECT: ", all_methods4xi(obj))
    print('=' *33)   

    # ---------------------------------------------------------------------------------------------
    # Methods compatible with multiprocessing
    # ---------------------------------------------------------------------------------------------
    #print("\n : ", obj.()) <--- copy and paste to test the methods returning something
    
    #obj.start()  <--- skip this method test in this function and test other methods 
    
    # ---------------------------------------------------------------------------------------------
    # Methods added by DragonXi
    # ---------------------------------------------------------------------------------------------
    print('=' *33)       
    print("\n SENSE: ", obj.sense())
    print('=' *33)       
    
    print('=' *33)       
    print("\n REASON: ", obj.reason())
    print('=' *33)       
    
    print('=' *33)       
    print("\n ACE: ", obj.ace())
    print('=' *33) 
      
    # ---------------------------------------------------------------------------------------------
    # End of test
    # ---------------------------------------------------------------------------------------------
    print('=' *33)   
    print("\n TEST COMPLETED")
    print('=' *33)   
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "test2syncmanager4xi" usage = "
#   testing Syncmanager4Xi
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#"> 
# -------------------------------------------------------------------------------------------------    
def test2syncmanager4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF TEST_SYNCMANAGER4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
        print('=' *33)
        print("\n (STEP 1/12) OF TEST_SYNCMANAGER4XI STARTED")
        print(time4xi())             
        print('=' *33)

        # ---------------------------------------------------------------------------------------------
        # Initializations for the object (commented if not required for this module)
        # ---------------------------------------------------------------------------------------------    
    
            
        # ---------------------------------------------------------------------------------------------
        # token2xi object
        # --------------------------------------------------------------------------------------------- 
        typeid2xi = "ip"
        address2xi = ('localhost', 8080)
        id2xi = "yourdragonxi.com"
        token2xi = Token4Xi(typeid2xi, address2xi, id2xi)
        
        print('=' *33)
        print("\n (STEP 2/12) OF TEST_SYNCMANAGER4XI - TOKEN OBJECTS CREATED")
        print(time4xi())             
        print('=' *33)
    
        # ---------------------------------------------------------------------------------------------
        # communication objects
        # ---------------------------------------------------------------------------------------------
        registry2xi =  {}
        authkey2xi = os.urandom(32)
        serializer2xi='pickle'
        # server2xi = Server4Xi(registry2xi, address2xi, authkey2xi, serializer2xi)
        
        print('=' *33)
        print("\n (STEP 3/12) OF TEST_SYNCMANAGER4XI - COMMUNICATION OBJECTS CREATED")
        print(time4xi())             
        print('=' *33)
            
        # ---------------------------------------------------------------------------------------------
        # manager objects
        # ---------------------------------------------------------------------------------------------
        manager2xi = Manager4Xi()

        
        
        print('=' *33)
        print("\n (STEP 4/12) OF TEST_SYNCMANAGER4XI - MANAGER OBJECT CREATED")
        print(time4xi())             
        print('=' *33)
        
        # ---------------------------------------------------------------------------------------------
        # misc objects
        # ---------------------------------------------------------------------------------------------
        exposed2xi=('sense', 'reason', 'ace')
        incref2xi=True
        cache2xi={}
        s2xi = 'AutoProxyXi'
        name2xi = 'AutoProxy[%s2xi]'
        lock2xi = Lock4Xi()
        
        print('=' *33)
        print("\n (STEP 5/12) OF TEST_SYNCMANAGER4XI - MISC OBJECTS CREATED")
        print(time4xi())             
        print('=' *33)
         
        # ---------------------------------------------------------------------------------------------
        # Array
        # Type code C Type Python Type Minimum size in bytes 
        # 'c' char character 1 
        # 'b' signed char int 1 
        # 'B' unsigned char int 1 
        # 'u' Py_UNICODE Unicode character 2 
        # 'h' signed short int 2 
        # 'H' unsigned short int 2 
        # 'i' signed int int 2 
        # 'I' unsigned int long 2 
        # 'l' signed long int 4 
        # 'L' unsigned long long 4 
        # 'f' float float 4 
        # 'd' double float 8 
        # ---------------------------------------------------------------------------------------------
        typecode2xi = 'u'
        sequence2xi = []
        
        # ---------------------------------------------------------------------------------------------
        # building keywords
        # ---------------------------------------------------------------------------------------------
        kwds2xi = {}
        #kwds2xi['authkey'] = authkey2xi
        kwds2xi['incref'] = True
    
        # ---------------------------------------------------------------------------------------------
        # arrays tested
        # ---------------------------------------------------------------------------------------------    
        au = "\N{GREEK CAPITAL LETTER DELTA}"  
        bu = "\u0394"
        cu = "\U00000394"
        creekarray2xi = [au, bu, cu]
        sequence2xi = creekarray2xi
        
        print('=' *33)
        print("\n (STEP 6/12) OF TEST_SYNCMANAGER4XI - ARRAYS CREATED")
        print(time4xi())             
        print('=' *33)
         
        # ---------------------------------------------------------------------------------------------
        # creation of the test object from its class (if available)
        # ---------------------------------------------------------------------------------------------
        list2xi = ListProxy4Xi(BaseListProxy4Xi)
        
        
        
        print('=' *33)
        print("\n (STEP 7/12) OF TEST_SYNCMANAGER4XI - LIST PROXY CREATED")
        print(time4xi())             
        print('=' *33)
           
        # ---------------------------------------------------------------------------------------------
        # registrating for multiprocessing with SyncManager4Xi without starting SyncManager4Xi object
        # ---------------------------------------------------------------------------------------------    
        print("\n REGISTRATING FOR MULTIPROCESSING WITH SYNCMANAGER4XI WITHOUT STARTING SYNCMANAGER4XI OBJECT")
        
        SyncManager4Xi.register('Queue', queue.Queue)
        SyncManager4Xi.register('JoinableQueue', queue.Queue)
        SyncManager4Xi.register('Event', threading.Event, EventProxy)
        SyncManager4Xi.register('Lock', threading.Lock, AcquirerProxy)
        SyncManager4Xi.register('RLock', threading.RLock, AcquirerProxy)
        SyncManager4Xi.register('Semaphore', threading.Semaphore, AcquirerProxy)
        SyncManager4Xi.register('BoundedSemaphore', threading.BoundedSemaphore, AcquirerProxy)
        SyncManager4Xi.register('Condition', threading.Condition, ConditionProxy)
        SyncManager4Xi.register('Pool', Pool, PoolProxy)
        SyncManager4Xi.register('list', list, ListProxy)
        SyncManager4Xi.register('dict', dict, DictProxy)
        SyncManager4Xi.register('Value', Value, ValueProxy)
        SyncManager4Xi.register('Array', Array, ArrayProxy)
        SyncManager4Xi.register('Namespace', Namespace, NamespaceProxy)
        SyncManager4Xi.register('Iterator', proxytype=IteratorProxy, create_method=False)
        SyncManager4Xi.register('AsyncResult', create_method=False) 
        
        
        # ---------------------------------------------------------------------------------------------
        # registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object
        # ---------------------------------------------------------------------------------------------    
        print("\n REGISTRATING WITH SYNCMANAGER4XI WITH DRAGONIZED PROXIES & WITHOUT STARTING SYNCMANAGER4XI OBJECT")
        SyncManager4Xi.register('Queue', queue.Queue)
        SyncManager4Xi.register('JoinableQueue', queue.Queue)
        SyncManager4Xi.register('Event', threading.Event, EventProxy4Xi)
        SyncManager4Xi.register('Lock', threading.Lock, AcquirerProxy4Xi)
        SyncManager4Xi.register('RLock', threading.RLock, AcquirerProxy4Xi)
        SyncManager4Xi.register('Semaphore', threading.Semaphore, AcquirerProxy4Xi)
        SyncManager4Xi.register('BoundedSemaphore', threading.BoundedSemaphore, AcquirerProxy4Xi)
        SyncManager4Xi.register('Condition', threading.Condition, ConditionProxy4Xi)
        SyncManager4Xi.register('Pool', Pool, PoolProxy4Xi)
        SyncManager4Xi.register('list', list, ListProxy4Xi)
        SyncManager4Xi.register('dict', dict, DictProxy4Xi)
        SyncManager4Xi.register('Value', Value, ValueProxy4Xi)
        SyncManager4Xi.register('Array', Array, ArrayProxy4Xi)
        SyncManager4Xi.register('Namespace', Namespace, NamespaceProxy4Xi)
        SyncManager4Xi.register('Iterator', proxytype=IteratorProxy4Xi, create_method=False)
        SyncManager4Xi.register('AsyncResult', create_method=False)     
        
        # ---------------------------------------------------------------------------------------------
        # registrating with SyncManager4Xi with dragonized classes and proxies & without starting SyncManager4Xi object
        # ---------------------------------------------------------------------------------------------    
        print("\n REGISTRATING WITH SYNCMANAGER4XI WITH DRAGONIZED PROXIES & WITHOUT STARTING SYNCMANAGER4XI OBJECT")
        SyncManager4Xi.register('Queue4Xi', queue.Queue)
        SyncManager4Xi.register('JoinableQueue4Xi', queue.Queue)
        SyncManager4Xi.register('Event', threading.Event, EventProxy4Xi)
        SyncManager4Xi.register('Lock4Xi', threading.Lock, AcquirerProxy4Xi)
        SyncManager4Xi.register('RLock4Xi', threading.RLock, AcquirerProxy4Xi)
        SyncManager4Xi.register('Semaphore4Xi', threading.Semaphore, AcquirerProxy4Xi)
        SyncManager4Xi.register('BoundedSemaphore4Xi', threading.BoundedSemaphore, AcquirerProxy4Xi)
        SyncManager4Xi.register('Condition4Xi', threading.Condition, ConditionProxy4Xi)
        SyncManager4Xi.register('Pool4Xi', Pool, PoolProxy4Xi)
        SyncManager4Xi.register('list', list, ListProxy4Xi)
        SyncManager4Xi.register('dict', dict, DictProxy4Xi)
        SyncManager4Xi.register('Value4Xi', Value, ValueProxy4Xi)
        SyncManager4Xi.register('Array4Xi', Array, ArrayProxy4Xi)
        SyncManager4Xi.register('Namespace4Xi', Namespace, NamespaceProxy4Xi)
        SyncManager4Xi.register('Iterator', proxytype=IteratorProxy4Xi, create_method=False)
        SyncManager4Xi.register('AsyncResult', create_method=False)     
      
    
            
            
        # ---------------------------------------------------------------------------------------------
        # calling the function - skip if object such as a server would loop indefinetely)
        # note: either a class object is created or a function is returned
        # ---------------------------------------------------------------------------------------------
        xi2a = Array4Xi(typecode2xi, sequence2xi, lock2xi)
    
        
        # ---------------------------------------------------------------------------------------------
        # creating the xi object from a class
        # ---------------------------------------------------------------------------------------------    
        xi = DragonXi()
        print ("\n xi object created ok")    
    
        
        print('=' *33)
        print("\n (STEP 8/12) OF TEST_SYNCMANAGER4XI - CREATED DRAGONXI OBJECT")
        print(time4xi())             
        print('=' *33)
                 
        # ---------------------------------------------------------------------------------------------
        # pass the tests if the object such as a server would start an infinite loop
        # ---------------------------------------------------------------------------------------------
        Listener4Xi, Client4Xi = syncmanager2xi[serializer2xi]
        
        conn2xi = Client4Xi(address2xi, get_default_family4xi(), authkey2xi)
        kind2xi, result2xi = conn2xi.recv()
        c2xi = "debug_info"   
        
    
        # ---------------------------------------------------------------------------------------------
        # registrating for multiprocessing with SyncManager4Xi without starting SyncManager4Xi object
        # ---------------------------------------------------------------------------------------------    
        
        print("\n REGISTRATING FOR MULTIPROCESSING WITH SYNCMANAGER4XI WITH SYNCMANAGER4XI OBJECT")
        xi.register('Queue', queue.Queue)
        xi.register('JoinableQueue', queue.Queue)
        xi.register('Event', threading.Event, EventProxy)
        xi.register('Lock', threading.Lock, AcquirerProxy)
        xi.register('RLock', threading.RLock, AcquirerProxy)
        xi.register('Semaphore', threading.Semaphore, AcquirerProxy)
        xi.register('BoundedSemaphore', threading.BoundedSemaphore, AcquirerProxy)
        xi.register('Condition', threading.Condition, ConditionProxy)
        xi.register('Pool', Pool, PoolProxy)
        xi.register('list', list, ListProxy)
        xi.register('dict', dict, DictProxy)
        xi.register('Value', Value, ValueProxy)
        xi.register('Array', Array, ArrayProxy)
        xi.register('Namespace', Namespace, NamespaceProxy)
        xi.register('Iterator', proxytype=IteratorProxy, create_method=False)
        xi.register('AsyncResult', create_method=False) 
        
        # ---------------------------------------------------------------------------------------------
        # registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object
        # ---------------------------------------------------------------------------------------------    
        print("\n REGISTRATING WITH SYNCMANAGER4XI WITH DRAGONIZED PROXIES WITH OBJECT")
        xi.register('Queue', queue.Queue)
        xi.register('JoinableQueue', queue.Queue)
        xi.register('Event', threading.Event, EventProxy4Xi)
        xi.register('Lock', threading.Lock, AcquirerProxy4Xi)
        xi.register('RLock', threading.RLock, AcquirerProxy4Xi)
        xi.register('Semaphore', threading.Semaphore, AcquirerProxy4Xi)
        xi.register('BoundedSemaphore', threading.BoundedSemaphore, AcquirerProxy4Xi)
        xi.register('Condition', threading.Condition, ConditionProxy4Xi)
        xi.register('Pool', Pool, PoolProxy4Xi)
        xi.register('list', list, ListProxy4Xi)
        xi.register('dict', dict, DictProxy4Xi)
        xi.register('Value', Value, ValueProxy4Xi)
        xi.register('Array', Array, ArrayProxy4Xi)
        xi.register('Namespace', Namespace, NamespaceProxy4Xi)
        xi.register('Iterator', proxytype=IteratorProxy4Xi, create_method=False)
        xi.register('AsyncResult', create_method=False)     
        
        # =============================================================================================================
        # registrating with SyncManager4Xi with dragonized classes AND proxies & without starting SyncManager4Xi object
        # * keeping old names would quarantee compatibility
        # * registering new names will create namespace DragonXi2 and take new modules into use
        # * xi = Manager4Xi() would call SyncManager in managers.py i.e. this would be the compatibility mode to use
        # * in this module calling xi's start method a dragonized SynManager4Xi object is started   
        # =============================================================================================================
        print("\n registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object")
        
        print('=' *33)
        print("\n (STEP 10/12) OF TEST_SYNCMANAGER4XI - REGISTRATING WITH SYNCMANAGER4XI OBJECT")
        print(time4xi())             
        print('=' *33)
         
        # ---------------------------------------------------------------------------------------------
        # Queue4Xi <--- Queue of managers.py <--- queue.Queue
        # ---------------------------------------------------------------------------------------------     
        xi.register('Queue4Xi', Queue4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # JoinableQueue4Xi <--- JoinableQueue of managers.py <--- queue.Queue
        # ---------------------------------------------------------------------------------------------
        xi.register('JoinableQueue4Xi', queue.Queue)
        
        # ---------------------------------------------------------------------------------------------
        # Event4Xi <--- Event of managers.py <--- threading.Event <--- threading.Event
        # ---------------------------------------------------------------------------------------------
        xi.register('Event4Xi', Event4Xi, EventProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # Lock4Xi <-- Lock/synchronize.py and AcquirerProxy4Xi <-- AcquirerProxy/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('Lock4Xi', Lock4Xi, AcquirerProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # RLock4Xi <-- RLock/synchronize.py and AcquirerProxy4Xi <-- AcquirerProxy/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('RLock4Xi', threading.RLock, AcquirerProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # Semaphore4Xi <--- Semaphore/synchronize.py <--- threading.Semaphore and  AcquirerProxy4Xi <-- AcquirerProxy/managers.p
        # ---------------------------------------------------------------------------------------------
        xi.register('Semaphore4Xi', Semaphore4Xi, AcquirerProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # BoundedSemaphore4Xi <--- BoundedSemaphore/synchronize.py <--- threading.BoundedSemaphore and  AcquirerProxy4Xi <-- AcquirerProxy/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('BoundedSemaphore4Xi', BoundedSemaphore4Xi, AcquirerProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # Condition4Xi <--- Condition/synchronize.py <--- threading.Condition and ConditionProxy4Xi <--- ConditionProxy/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('Condition4Xi', Condition4Xi, ConditionProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # Pool4Xi <--- Pool/pool.py and PoolProxy4Xi <--- PoolProxy/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('Pool4Xi', Pool, PoolProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # list <--- Python and ListProxy4Xi <--- ListProxy/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('list', list, ListProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # dict <--- Python and DictProxy4Xi <-- DictProxy/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('dict', dict, DictProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # Value4Xi <--- Value/managers.py and ValueProxy4Xi <--- ValueProxy/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('Value4Xi', Value4Xi, ValueProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # Array4Xi <--- Array/managers.py and ArrayProxy4Xi <--- ArrayProxy/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('Array4Xi', Array4Xi, ArrayProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # Namespace4Xi <--- Namespace/managers.py and NamespaceProxy4Xi/managers.py
        # ---------------------------------------------------------------------------------------------
        xi.register('Namespace4Xi', Namespace4Xi, NamespaceProxy4Xi)
        
        # ---------------------------------------------------------------------------------------------
        # Iterator and IteratorProxy4Xi <--- IteratorProxy/managers.py                                *
        # ---------------------------------------------------------------------------------------------
        xi.register('Iterator', proxytype=IteratorProxy4Xi, create_method=False)
        
        # ---------------------------------------------------------------------------------------------
        # AsyncResult <--- PoolProxy._method_to_typeid_/managers.py and PoolProxy4Xi/poolproxy2xi.py  *
        # ---------------------------------------------------------------------------------------------
        xi.register('AsyncResult', create_method=False)     
      

        print('=' *33)
        print("\n (STEP 11/12) OF TEST_SYNCMANAGER4XI - XI OBJECT PASSED TEST FUNCTION AFTER REGISTRATION OF DRAGONIZED OBJECTS OK!")
        print(time4xi())             
        print('=' *33)
            
               
        # ---------------------------------------------------------------------------------------------
        # start
        # ---------------------------------------------------------------------------------------------
        xi.start()

        print('=' *33)
        print("\n (STEP 12/12A) STARTED WITH SYNCMANAGER4XI OBJECT XI!")
        print(time4xi())             
        print('=' *33)
                

        
        # ---------------------------------------------------------------------------------------------
        print("\n  (STEP 12/12b) SUMMARY - STATUS TO BE UPDATED :")
        print("\n 1) REGISTRATING FOR MULTIPROCESSING WITH SYNCMANAGER4XI without starting SyncManager4Xi object ok")
        print("\n    registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object ok")
        print("\n    registrating with SyncManager4Xi with dragonized classes and proxies & without starting SyncManager4Xi object ok")
        
        print("\n 2) XI OBJECT FROM DRAGONXI  - STATUS TO BE UPDATED :")
        print("\n    xi object passed test function ok")
        print("\n    xi registrating for multiprocessing with SyncManager4Xi without starting SyncManager4Xi object ok")
        print("\n    xi registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object ok")
        print("\n    xi registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object ok")
    
        print("\n 3) XI.START  - STATUS TO BE UPDATED :")
        print("\n    status to be updated")
        print("\n    ")    
        
        
        print(time4xi())             
        print('=' *33)
   
    except:
        pass
    finally:
        # ---------------------------------------------------------------------------------------------    
        # PRINT TRACE
        # ---------------------------------------------------------------------------------------------
        
        print('=' *33)
        print("\n (STEP 12/12C) OF TEST_SYNCMANAGER4XI - PRINT TRACE")
        print(time4xi())             
        print('=' *33)
                 
        print_trace4xi(t2xi)           
#</function4xi>    
                
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   testing Syncmanager4Xi
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#">                       
# -------------------------------------------------------------------------------------------------    
def main():
    
    test2syncmanager4xi()
    
#</function4xi>

            
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()

   
#</program4xi>
# -------------------------------------------------------------------------------------------------
# History of test_syncmanager4xi                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_sync_manager_test4xi.txt
#   sense-sync-manager-test4xi.xml
#   reason-sync-manager-test4xi.xml
#   ace-sync-manager-test4xi.xml

# 
#  ======================================================================
# 09:42:40 12/01/08 FLE Standard Time
# Monday (Mon) 01/12/2008
# Analysis:
# - pickling error multiprocessing.managers.PoolProxy4Xi not found <==> looks like system tries to pickle from managers.py ! 
# - this strategy created both multiprocessing and dragonized multiprocessing objects !
# 
#  xi object created ok
# 
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# 
#  test_syncmanager4xi
# 
#  syncmanager2xi all methods:  ['Array', 'BoundedSemaphore', 'Condition', 'Event', 'JoinableQueue', 'Lock', 'Namespace', 'Pool', 'Queue', 'RLock', 'Semaphore', 'Value', '_Client', '_Listener', '_Server', '__class__', '__delattr__', '__enter__', '__eq__', '__exit__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '_create', '_debug_info', '_finalize_manager', '_number_of_objects', '_run_server', 'ace', 'connect', 'dict', 'get_server', 'join', 'list', 'reason', 'register', 'sense', 'start']
# 
#  start:  skipped
# 
#  sense:  True
# 
#  reason:  True
# 
#  ace:  True
# 
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# 
#  xi object passed test function before registration ok
# 
#  registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object
# 
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# 
#  test_syncmanager4xi 
# 
#  syncmanager2xi all methods:  ['Array', 'Array4Xi', 'BoundedSemaphore', 'BoundedSemaphore4Xi', 'Condition', 'Condition4Xi', 'Event', 'Event4Xi', 'JoinableQueue', 'JoinableQueue4Xi', 'Lock', 'Lock4Xi', 'Namespace', 'Namespace4Xi', 'Pool', 'Pool4Xi', 'Queue', 'Queue4Xi', 'RLock', 'RLock4Xi', 'Semaphore', 'Semaphore4Xi', 'Value', 'Value4Xi', '_Client', '_Listener', '_Server', '__class__', '__delattr__', '__enter__', '__eq__', '__exit__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '_create', '_debug_info', '_finalize_manager', '_number_of_objects', '_run_server', 'ace', 'connect', 'dict', 'get_server', 'join', 'list', 'reason', 'register', 'sense', 'start']
# 
#  start:  skipped
# 
#  sense:  True
# 
#  reason:  True
# 
#  ace:  True
# 
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# 
#  xi object passed test function after registration of dragonized objects ok
#  ======================================================================
# 11:33:18 11/28/08 FLE Standard Time
# Friday (Fri) 28/11/2008
# 
#  registrating for multiprocessing with SyncManager4Xi without starting SyncManager4Xi object
# 
#  registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object
# 
#  registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object
# 
#  xi object created ok
# 
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# 
#  test_syncmanager4xi
# 
#  syncmanager2xi all methods:  ['Array', 'Array4Xi', 'BoundedSemaphore', 'BoundedSemaphore4Xi', 'Condition', 'Condition4Xi', 'Event', 'Event4Xi', 'JoinableQueue', 'JoinableQueue4Xi', 'Lock', 'Lock4Xi', 'Namespace', 'Namespace4Xi', 'Pool', 'Pool4Xi', 'Queue', 'Queue4Xi', 'RLock', 'RLock4Xi', 'Semaphore', 'Semaphore4Xi', 'Value', 'Value4Xi', '_Client', '_Listener', '_Server', '__class__', '__delattr__', '__enter__', '__eq__', '__exit__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '_create', '_debug_info', '_finalize_manager', '_number_of_objects', '_run_server', 'ace', 'connect', 'dict', 'get_server', 'join', 'list', 'reason', 'register', 'sense', 'start']
# 
#  start:  skipped
# 
#  sense:  None
# 
#  reason:  None
# 
#  ace:  None
# 
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# 
#  xi object passed test function ok
# 
#  registrating for multiprocessing with SyncManager4Xi without starting SyncManager4Xi object
# 
#  registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object
# 
#  registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object
# 
#  test_syncmanager4xi
# 
#  Summary:
# 
#  1) registrating for multiprocessing with SyncManager4Xi without starting SyncManager4Xi object ok
# 
#     registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object ok
# 
#     registrating with SyncManager4Xi with dragonized classes and proxies & without starting SyncManager4Xi object ok
# 
#  2) xi object from DragonXi class created ok
# 
#     xi object passed test function ok
# 
#     xi registrating for multiprocessing with SyncManager4Xi without starting SyncManager4Xi object ok
# 
#     xi registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object ok
# 
#     xi registrating with SyncManager4Xi with dragonized proxies & without starting SyncManager4Xi object ok
# 
#  3) xi.start (spawns a server process for xi object) tests:
# 
#     no tests 
# 
#     
# 11:33:18 11/28/08 FLE Standard Time
# Friday (Fri) 28/11/2008
# 
#  ======================================================================

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_syncmanager4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>

